<?php
/*===============================================================================
Setup script database tables for sNews 1.5
Written by Onno Brauckmann; copyright 2007 www.hbwconsultants.nl / www.brauck.nl
This script is licensed under a Creative Commons License and is distributed in
the hope that it will be to some use, but WITHOUT ANY WARRANTY.
version 1.0.5

Usage:
Create your snews database, set the variables at the top of snews.php, upload
your snews package to your server and point your browser to this script.
The script checks if the website url and the database variables in snews.php
are set. If they are not completed, the script will give an error message and is
terminated. If the variables are properly set the script creates the database
tables using these settings and stores the needed data in the settings table.
This script must be in the same folder as snews.php
===============================================================================*/

error_reporting(0);

// messages
function message($var) {
 $message = array();
 $message['no_db'] = '<p>There was an error connecting to the database.</p><p>Please check your Database information and <a href="install.php">try</a> again.</p>';
 $message['connected'] = 'Succesful connection to database';
 $message['error'] = '<p class="red"><strong>Error!!</strong></p>';
 $message['snews_notfound'] = '<p>Can\'t find your \'snews.php\'! Please make sure that both \'install.php\' and \'snews.php\' are in the same folder and <a href="install.php">try</a> again.</p>';
 $message['no_dbvariables'] = '<p>One or more of the database variables in \'snews.php\' are not set, please check these variables at the top of your \'snews.php\'-file and <a href="install.php">try</a> again.</p>';
 $message['creating_tables'] = '<p>Creating tables.</p><br />';
 $message['creating_table'] = 'Creating the table ';
 $message['storing_data'] = 'Storing data in table ';
 $message['data_stored'] = '<p class="green"><strong>Storing data succesfull.</strong></p><br />';
 $message['error_storing_data'] = '<p>There was an error storing the data in the table .</p><p>Please check and <a href="install.php">try</a> again</p>';
 $message['table_created'] = '<p class="green"><strong>Table has been created.</strong></p><br />';
 $message['table_error'] = '<p class="red"><strong>Error!!</strong></p><p>There was an error creating the table.</p><p>Please check your database settings and <a href="install.php">try</a> again</p>';
 $message['table_exist'] = '<p class="red">Could not create; table already exists</p><br />';
 $message['check'] = '<p class="red"><strong>One or more tables could not be created, so you better check your database!</strong></p>';
 $message['all_done'] = '<p class="green"><strong>All tables created and data stored in the settings table.</strong></p>';
  return $message[$var];
}

function mysql_table_exists($table) {
  global $m;
  echo '<p>' . message('creating_table') . $table . '</p>' ;
    wait(1);
  $result = mysql_list_tables(db('dbname'));
  if(mysql_num_rows( mysql_query("SHOW TABLES LIKE '". $table ."'"))) {
    echo message('table_exist');
    $m = TRUE;
    return true;
  }else {
    return false;
  }
}

function makeTable_articles($connection, $table) {

  $sql ="CREATE TABLE IF NOT EXISTS " . $table . "
  (
	id int(11) primary key auto_increment,
	title varchar(100) default NULL,
	seftitle varchar(100) default NULL,
  	`text` longtext,
  	`date` datetime default NULL,
  	category int(8) NOT NULL default '0',
  	position int(6) default NULL,
  	displaytitle char(3) NOT NULL default 'YES',
  	displayinfo char(3) NOT NULL default 'YES',
  	commentable varchar(5) NOT NULL default '',
  	published int(3) NOT NULL default '1',
  	description_meta varchar(255) default NULL,
  	keywords_meta varchar(255) default NULL
  )";

  $result = @mysql_query($sql,$connection);
  if ($result) {
	echo message('table_created');

 }else{
    echo message('table_error');
	exit;
 }
}

function makeTable_categories($connection, $table) {

  $sql ="CREATE TABLE IF NOT EXISTS " . $table . "
  (
  	id int(8) primary key auto_increment,
 	name varchar(100) NOT NULL,
 	seftitle varchar(100) NOT NULL,
 	description varchar(255) NOT NULL,
 	published varchar(4) NOT NULL default 'YES',
 	catorder smallint(6) NOT NULL default '0'
  )";

  $result = @mysql_query($sql,$connection);
  if ($result) {
	echo  message('table_created');
 }else{
    echo message('table_error');
	exit;
 }
}

function makeTable_comments($connection, $table) {

  $sql ="CREATE TABLE IF NOT EXISTS " . $table . "
  (
 	id int(11) primary key auto_increment,
 	articleid int(11) default '0',
 	name varchar(50),
 	url varchar(100) NOT NULL,
 	comment text,
 	time datetime NOT NULL default '0000-00-00 00:00:00',
 	approved varchar(5) NOT NULL default 'True'
  )";

  $result = @mysql_query($sql,$connection) or die(mysql_error());

  if ($result) {
	echo  message('table_created');
 }else{
    echo message('table_error');
	exit;
 }
}

function makeTable_settings($connection, $table) {

  $sql ="CREATE TABLE IF NOT EXISTS " . $table . "
  (
 	id int(8) primary key auto_increment,
 	name varchar(20) NOT NULL,
 	value varchar(60) NOT NULL
  )";

  $result = @mysql_query($sql,$connection) or die(mysql_error());
  if ($result) {
	echo  message('table_created');
 }else{
    echo message('table_error');
	exit;
 }
}

function fillTable_settings($connection, $table) {

  echo '<p>' . message('storing_data') . $table . '.</p>';
  $sql = array (
	"INSERT INTO " . db('prefix') . "settings VALUES  (1, 'website_title', 'sNews 1.5');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (2, 'home_sef', 'home');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (3, 'website_description', 'sNews CMS');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (4, 'website_keywords', 'new, site, snews');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (5, 'website_email', 'info@mydomain.com');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (6, 'contact_subject', 'Contact Form');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (7, 'language', 'EN');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (8, 'charset', 'UTF-8');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (9, 'date_format', 'd.m.Y. H:i');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (10, 'article_limit', '3');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (11, 'rss_limit', '5');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (12, 'display_page', '');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (13, 'display_new_on_home', '');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (14, 'display_pagination', '');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (15, 'num_categories', 'on');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (16, 'approve_comments', '');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (17, 'comments_order', 'ASC');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (18, 'comment_limit', '30');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (19, 'word_filter_enable', '');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (20, 'word_filter_file', '');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (21, 'word_filter_change', '');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (22, 'username', 'test');",
	"INSERT INTO " . db('prefix') . "settings VALUES  (23, 'password', '098f6bcd4621d373cade4e832627b4f6');"
 );

 for($i=0; $i<=22; $i++) {
  $result = @mysql_query($sql[$i],$connection);
 }

 if ($result) {
	echo message('data_stored');
 }else {
    echo message('error');
    echo message('error_storing_data');
    exit;
 }
}

function wait($secs) {
 ob_flush(); flush(); sleep($secs);
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
  <title>Installation sNews database</title>
  <meta name="author" content="hbwConsultants b.v. - Bennebroek (www.hbwconsultants.nl)" />
  <style>
  * {margin: 0; padding: 0;}
  body {
  margin: 20px 0;
  font-family: Tahoma, Arial, sans-serif;
  font-size: 11px;
  line-height: 1.6em;
  color: #666;
  background-color: #fff;
  text-align: center;
  }
  h1 {font-size: 32px;color: #cc6633;margin: 0 0 30px 0;background-color:inherit;}
  a:link, a:visited, a:active {color:#cc6714;text-decoration: underline;}
  a:hover {color:#cc6714; text-decoration: none;}
  .red {color: #ff0000;}
  .green {color: #339933;}
  #container {width: 750px;margin: 0 auto;text-align: left;}
  #header {border-bottom: 4px solid #948979;padding: 10px 0 0 0;clear: both;margin: 0 0 10px 0;}
  </style>
</head>

<body>
  <div id="container">
	<div id="header">
	  <h1>Setup sNews database tables</h1>
	  <p>This script creates the tables in the sNews database</p>
	</div>
<?php
  //check if snews.php is available
  if (!file_exists('snews.php')) {
    echo message('error');
    echo message('snews_notfound');
    exit;
 }else {
    include_once ('snews.php');
 }

  // check if all db variables are filled in except the prefix
  if (!db('website') || !db('dbname') || !db('dbhost') || !db('dbuname') || !db('dbpass')) {
    echo message('error');
    echo message('no_dbvariables');
    exit;
  }

  //check connection to dbase verifing dbase name, server, username and password (not really
  // necessary because snews.php is doing that.
  $connection = @mysql_connect(db('dbhost'), db('dbuname'), db('dbpass'));
  $db = @mysql_select_db(db('dbname'),$connection);
  if (!$connection || !$db) {
    echo message('error');
    echo message('no_db');
	exit;
  }else {
    echo '<p class="green"><strong>' . message('connected') . ' ' . db('dbname') . '.</strong></p>';
  }

  echo message('creating_tables');
  wait(2);
  //check if the table exists; if not create the table
  if (!mysql_table_exists(db('prefix').'articles')) {
    makeTable_articles($connection, db('prefix').'articles');
    wait(1);
  }

  if (!mysql_table_exists(db('prefix').'categories')) {
    makeTable_categories($connection, db('prefix').'categories');
    wait(1);
  }

  if (!mysql_table_exists(db('prefix').'comments')) {
    makeTable_comments($connection, db('prefix').'comments');
    wait(1);
  }

  if (!mysql_table_exists(db('prefix').'settings')) {
    makeTable_settings($connection, db('prefix').'settings');
    wait(1);
    fillTable_settings($connection, db('prefix').'settings');
  }

  if ($m) {
   echo message('check');
  }else{
   echo message('all_done');
  }
?>
  </div>
</body>
</html>